package sdds;

/**
 * <p>Iterates through each key in a {@link HashTable}.</p>
 * 
 * @author Stephen G. Ware
 * @param <K> the key object for the hash table
 * @param <V> the value object for the hash table
 */
class HashTableKeyIterator<K, V> extends HashTableIterator<K, V> implements java.util.Iterator<K> {

	/**
	 * <p>Construct a key iterator for a given {@link HashTable}</p>
	 * 
	 * @param hashTable
	 */
	HashTableKeyIterator(HashTable<K, V> hashTable){
		super(hashTable);
	}
	
	/**
	 * <p>Get the next key from the hash table.</p>
	 * 
	 * @return the next key
	 */
	public K next(){
		return getNextNode().key;
	}
}
