package sdds;

/**
 * <p>Iterates through each value in a {@link HashTable}.</p>
 * 
 * @author Stephen G. Ware
 * @param <K> the key object for the hash table
 * @param <V> the value object for the hash table
 */
class HashTableValueIterator<K, V> extends HashTableIterator<K, V> implements java.util.Iterator<V> {

	/**
	 * <p>Construct a value iterator for a given {@link HashTable}</p>
	 * 
	 * @param hashTable
	 */
	HashTableValueIterator(HashTable<K, V> hashTable){
		super(hashTable);
	}
	
	/**
	 * <p>Get the next value from the hash table.</p>
	 * 
	 * @return the next value
	 */
	public V next(){
		return getNextNode().value;
	}
}
