package unit_tests;

import sdds.DList;

/**
 * <p>Tests for {@link sdds.DList}</p>
 * 
 * @author Stephen G. Ware
 */
public class DListTest extends ListTest {

	public void testArrayConstructor(){
		System.out.println("\n=== A DList can be constructed from an array. ===");
		System.out.print("Construct a list using an array of four objects.  The list should have 4 elements: ");
		DList<Item> list = new DList<Item>(fourItems);
		assertEquals(list.length(), 4);
		System.out.println(list.length());
		System.out.print("The list should contain those four items:");
		Item gotten;
		for(int i=0; i<list.length(); i++){
			gotten = list.get(i);
			System.out.print(" " + gotten);
			assertSame(gotten, fourItems[i]);
		}
		System.out.println();
	}
	
	public void testAddSize(){
		super.testAddLength(new DList<Item>());
	}
	
	public void testMultiAdd(){
		super.testMultiAdd(new DList<Item>());
	}
	
	public void testGetLast(){
		super.testGetLast(new DList<Item>());
	}
	
	public void testGet(){
		super.testGet(new DList<Item>());
	}
	
	public void testIterator(){
		super.testIterator(new DList<Item>());
	}
	
	public void testContains(){
		super.testContains(new DList<Item>());
	}
	
	public void testContainsEquals(){
		super.testContainsEquals(new DList<Item>());
	}
	
	public void testRemove(){
		super.testRemove(new DList<Item>());
	}
	
	public void testRemoveEquals(){
		super.testRemoveEquals(new DList<Item>());
	}
	
	public void testRemoveAll(){
		super.testRemoveAll(new DList<Item>());
	}
	
	public void testRemoveAllEquals(){
		super.testRemoveAllEquals(new DList<Item>());
	}
	
	public void testRemoveNonMember(){
		super.testRemoveNonMember(new DList<Item>());
	}
	
	public void testAddList(){
		super.testAddList(new DList<Item>(), new DList<Item>());
	}
	
	public void testToArray(){
		super.testToArray(new DList<Item>());
	}
	
	public void testDynamic(){
		System.out.println("\n=== Changing a DList should change the original. ===");
		DList<Item> list1 = new DList<Item>();
		DList<Item> list2;
		System.out.print("Begin with an empty dynamic list.  It should be length 0: ");
		assertEquals(list1.length(), 0);
		System.out.println(list1.length());
		System.out.print("Add " + a + ".  The returned (second) list should be of length 1: ");
		list2 = list1.add(ListTest.a);
		assertEquals(list2.length(), 1);
		System.out.println(list2.length());
		System.out.print("The the original (first) list should also be of length 1: ");
		assertEquals(list1.length(), 1);
		System.out.println(list1.length());
		System.out.print("The first and second list should be the same object: ");
		assertSame(list1, list2);
		System.out.print("they are\nRemove " + a + " from the second list.  It should now have 0 elements: ");
		list2 = list2.remove(a);
		assertEquals(list2.length(), 0);
		System.out.println(list2.length());
		System.out.print("The first list should also have 0 elements: ");
		assertEquals(list1.length(), 0);
		System.out.println(list1.length());
	}

	public void testEquals(){
		super.testEquals(new DList<Item>(), new DList<Item>());
	}
	
	public void testClone(){
		super.testClone(new DList<Item>());
	}
	
	public void testToString(){
		super.testToString(new DList<Item>());
	}
}
