package unit_tests;

import sdds.SList;

/**
 * <p>Tests for {@link sdds.SList}</p>
 * 
 * @author Stephen G. Ware
 */
public class SListTest extends ListTest {

	public void testArrayConstructor(){
		System.out.println("\n=== An SList can be constructed from an array. ===");
		System.out.print("Construct a list using an array of four objects.  The list should have 4 elements: ");
		SList<Item> list = new SList<Item>(fourItems);
		assertEquals(list.length(), 4);
		System.out.println(list.length());
		System.out.print("The list should contain those four items:");
		Item gotten;
		for(int i=0; i<list.length(); i++){
			gotten = list.get(i);
			System.out.print(" " + gotten);
			assertSame(gotten, fourItems[i]);
		}
		System.out.println();
	}
	
	public void testAddSize(){
		super.testAddLength(new SList<Item>());
	}
	
	public void testMultiAdd(){
		super.testMultiAdd(new SList<Item>());
	}
	
	public void testGetLast(){
		super.testGetLast(new SList<Item>());
	}
	
	public void testGet(){
		super.testGet(new SList<Item>());
	}
	
	public void testIterator(){
		super.testIterator(new SList<Item>());
	}
	
	public void testContains(){
		super.testContains(new SList<Item>());
	}
	
	public void testContainsEquals(){
		super.testContainsEquals(new SList<Item>());
	}
	
	public void testRemove(){
		super.testRemove(new SList<Item>());
	}
	
	public void testRemoveEquals(){
		super.testRemoveEquals(new SList<Item>());
	}
	
	public void testRemoveAll(){
		super.testRemoveAll(new SList<Item>());
	}
	
	public void testRemoveAllEquals(){
		super.testRemoveAllEquals(new SList<Item>());
	}
	
	public void testRemoveNonMember(){
		super.testRemoveNonMember(new SList<Item>());
	}
	
	public void testAddList(){
		super.testAddList(new SList<Item>(), new SList<Item>());
	}
	
	public void testToArray(){
		super.testToArray(new SList<Item>());
	}
	
	public void testStatic(){
		System.out.println("\n=== Changing an SList should change the original. ===");
		SList<Item> list1 = new SList<Item>();
		SList<Item> list2;
		System.out.print("Begin with an empty static list.  It should be length 0: ");
		assertEquals(list1.length(), 0);
		System.out.println(list1.length());
		System.out.print("Add " + a + ".  The returned (second) list should be of length 1: ");
		list2 = list1.add(ListTest.a);
		assertEquals(list2.length(), 1);
		System.out.println(list2.length());
		System.out.print("The the original (first) list should still be of length 0: ");
		assertEquals(list1.length(), 0);
		System.out.println(list1.length());
		System.out.print("The first and second list should not be the same object: ");
		assertNotSame(list1, list2);
		System.out.print("they are not\nRemove " + a + " from the second list, discarding the returned list.  It should still have 1 element: ");
		list2.remove(a);
		assertEquals(list2.length(), 1);
		System.out.println(list2.length());
	}

	public void testEquals(){
		super.testEquals(new SList<Item>(), new SList<Item>());
	}
	
	public void testClone(){
		super.testClone(new SList<Item>());
	}
	
	public void testToString(){
		super.testToString(new SList<Item>());
	}
}
